BayesianScoreQuery (Lucene 10.5.0 core API)
Description: declaration: package: org.apache.lucene.search, class: BayesianScoreQuery

Package org.apache.lucene.search

# Class BayesianScoreQuery

java.lang.Object
org.apache.lucene.search.Query
org.apache.lucene.search.BayesianScoreQuery

public final class BayesianScoreQuery extends Query
A query wrapper that transforms the inner query's score into a calibrated probability via sigmoid calibration: `P = sigmoid(alpha * (score - beta))`.

This implements the query-level Bayesian transform from "Bayesian BM25": the inner query (typically a multi-term BooleanQuery with BM25Similarity) produces a raw score, and this wrapper maps it to a probability in (0, 1) suitable for combination with other probability signals via `LogOddsFusionQuery`.

The alpha parameter controls the sigmoid steepness (score sensitivity), and beta controls the midpoint (decision boundary). These can be set manually or estimated from the score distribution via `BayesianScoreEstimator`.

An optional base rate encodes the corpus-level prior probability that a random document is relevant to a random query. When set, the posterior is computed in log-odds space: `sigmoid(alpha * (score - beta) + logit(baseRate))`. This shifts scores down for rare-relevance corpora, improving calibration.

WARNING: This API is experimental and might change in incompatible ways in the next release.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BayesianScoreQuery(Query query, float alpha, float beta)`
  Creates a BayesianScoreQuery without base rate.
  `BayesianScoreQuery(Query query, float alpha, float beta, float baseRate)`
  Creates a BayesianScoreQuery with base rate.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Weight`
  `createWeight(IndexSearcher searcher, ScoreMode scoreMode, float boost)`
  Expert: Constructs an appropriate Weight implementation for this query.
  `boolean`
  `equals(Object other)`
  Override and implement query instance equivalence properly in a subclass.
  `float`
  `getAlpha()`
  Returns the sigmoid steepness parameter.
  `float`
  `getBaseRate()`
  Returns the base rate, or 0 if not set.
  `float`
  `getBeta()`
  Returns the sigmoid midpoint parameter.
  `Query`
  `getQuery()`
  Returns the wrapped query.
  `int`
  `hashCode()`
  Override and implement query hash code properly in a subclass.
  `Query`
  `rewrite(IndexSearcher indexSearcher)`
  Expert: called to re-write queries into primitive queries.
  `String`
  `toString(String field)`
  Prints a query to a string, with `field` assumed to be the default field and omitted.
  `void`
  `visit(QueryVisitor visitor)`
  Recurse through the query tree, visiting any child queries.

  ### Methods inherited from class org.apache.lucene.search.Query

  `classHash, sameClassAs, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### BayesianScoreQuery

    public BayesianScoreQuery(Query query, float alpha, float beta, float baseRate)
    Creates a BayesianScoreQuery with base rate.
    Parameters:
      `query` - the inner query whose scores will be transformed
      `alpha` - sigmoid steepness (must be positive and finite)
      `beta` - sigmoid midpoint (must be finite)
      `baseRate` - corpus-level relevance prior in (0, 1), or 0 to disable. When positive, adds logit(baseRate) to the log-odds before sigmoid, shifting scores to account for the rarity of relevant documents.

  - ### BayesianScoreQuery

    public BayesianScoreQuery(Query query, float alpha, float beta)
    Creates a BayesianScoreQuery without base rate.
    Parameters:
      `query` - the inner query whose scores will be transformed
      `alpha` - sigmoid steepness (must be positive and finite)
      `beta` - sigmoid midpoint (must be finite)

- ## Method Details

  - ### getQuery

    public Query getQuery()
    Returns the wrapped query.

  - ### getAlpha

    public float getAlpha()
    Returns the sigmoid steepness parameter.

  - ### getBeta

    public float getBeta()
    Returns the sigmoid midpoint parameter.

  - ### getBaseRate

    public float getBaseRate()
    Returns the base rate, or 0 if not set.

  - ### createWeight

    public Weight createWeight(IndexSearcher searcher, ScoreMode scoreMode, float boost) throws IOException
    Description copied from class: `Query`
    Expert: Constructs an appropriate Weight implementation for this query.

    Only implemented by primitive queries, which re-write to themselves.

    Overrides:
      `createWeight` in class `Query`
    Parameters:
      `scoreMode` - How the produced scorers will be consumed.
      `boost` - The boost that is propagated by the parent queries.
    Throws:
      `IOException`

  - ### rewrite

    public Query rewrite(IndexSearcher indexSearcher) throws IOException
    Description copied from class: `Query`
    Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.

    Callers are expected to call `rewrite` multiple times if necessary, until the rewritten query is the same as the original query.

    The rewrite process may be able to make use of IndexSearcher's executor and be executed in parallel if the executor is provided.

    Overrides:
      `rewrite` in class `Query`
    Throws:
      `IOException`
    See Also:
      - `IndexSearcher.rewrite(Query)`

  - ### visit

    public void visit(QueryVisitor visitor)
    Description copied from class: `Query`
    Recurse through the query tree, visiting any child queries.
    Specified by:
      `visit` in class `Query`
    Parameters:
      `visitor` - a QueryVisitor to be called by each query in the tree

  - ### toString

    public String toString(String field)
    Description copied from class: `Query`
    Prints a query to a string, with `field` assumed to be the default field and omitted.
    Specified by:
      `toString` in class `Query`

  - ### equals

    public boolean equals(Object other)
    Description copied from class: `Query`
    Override and implement query instance equivalence properly in a subclass. This is required so that `QueryCache` works properly.

    Typically a query will be equal to another only if it's an instance of the same class and its document-filtering properties are identical to those of the other instance. Utility methods are provided for certain repetitive code.

    Specified by:
      `equals` in class `Query`
    See Also:
      - `Query.sameClassAs(Object)`
      - `Query.classHash()`

  - ### hashCode

    public int hashCode()
    Description copied from class: `Query`
    Override and implement query hash code properly in a subclass. This is required so that `QueryCache` works properly.
    Specified by:
      `hashCode` in class `Query`
    See Also:
      - `Query.equals(Object)`